package ch.zhaw.projekt2.turnierverwaltung;

import java.io.Serializable;

/**
 * Interface that defines the common functionality of a Participant, used by Players and Teams
 */
public interface Participant extends Serializable {
    /**
     * Method that will be used to get
     *
     * @return the name
     */
    String getName();

    /**
     * Method to set a participants name
     *
     * @param name to be set
     * @throws InvalidNameException if the name does not follow the correct format
     */
    void setName(String name) throws InvalidNameException;

    /**
     * Method to compare two participants with each other
     *
     * @param participant to be compared to the current instance
     * @return true if equal, false if not
     */
    boolean equals(Participant participant);

    /**
     * Method to  change out participants
     *
     * @param participant to be exchanged
     * @throws Person.InvalidPhoneNumberException if phone number does not follow the correct formatting
     */
    void change(Participant participant) throws Person.InvalidPhoneNumberException;
}
